%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%if 0%{?fedora}
# There are some missing deps
%global with_python3 1
%endif

%global pypi_name os-brick

%global common_desc \
OpenStack Cinder brick library for managing local volume attaches

Name:           python-%{pypi_name}
Version:        2.3.9
Release:        7%{?dist}
Summary:        OpenStack Cinder brick library for managing local volume attaches

License:        ASL 2.0
URL:            http://www.openstack.org/
Source0:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=2.3.9
Patch0001: 0001-Improve-iSCSI-device-detection-speed.patch
Patch0002: 0002-Handle-None-value-inititator_target_map.patch
Patch0003: 0003-Fix-FC-scan-too-broad.patch
Patch0004: 0004-rbd-Use-showmapped-to-find-the-root-RBD-device-durin.patch
Patch0005: 0005-rbd-Correct-local_attach-disconnect-test-and-showmap.patch
Patch0006: 0006-Remove-VxFlex-OS-credentials-from-connection_propert.patch
Patch0007: 0007-Fix-Remove-VxFlex-OS-credentials-regression.patch
Patch0008: 0008-Read-mounts-from-proc-mounts-instead-of-running-moun.patch
Patch0009: 0009-linuxscsi-Stop-waiting-for-multipath-devices-during-.patch
Patch0010: 0010-iscsi-Add-_get_device_link-retry-when-waiting-for-de.patch

BuildArch:      noarch

%description
%{common_desc}

%package -n python2-%{pypi_name}
Summary:        OpenStack Cinder brick library for managing local volume attaches
%{?python_provide:%python_provide python2-%{pypi_name}}
Provides:       os-brick = %{version}-%{release}

Requires:       python2-pbr
Requires:       python2-babel >= 2.3.4
Requires:       python2-eventlet >= 0.18.2
Requires:       python2-oslo-concurrency >= 3.25.0
Requires:       python2-oslo-i18n >= 3.15.3
Requires:       python2-oslo-log >= 3.36.0
Requires:       python2-oslo-service >= 1.24.0
Requires:       python2-oslo-utils >= 3.33.0
Requires:       python2-requests >= 2.14.2
Requires:       python2-six >= 1.10.0
Requires:       python2-oslo-privsep >= 1.23.0
Requires:       python2-os-win >= 3.0.0
%if 0%{?fedora} > 0
Requires:       python2-retrying
%else
Requires:       python-retrying
%endif
Requires:       device-mapper-multipath
Requires:       sg3_utils
Requires:       sysfsutils

BuildRequires:  python2-devel
BuildRequires:  python2-ddt
BuildRequires:  python2-pbr >= 2.0.0
BuildRequires:  git
BuildRequires:  python2-reno
BuildRequires:  python2-sphinx
BuildRequires:  python2-oslo-concurrency  >= 3.8.0
BuildRequires:  python2-oslo-i18n >= 3.15.3
BuildRequires:  python2-oslo-log >= 3.36.0
BuildRequires:  python2-oslo-service >= 1.24.0
BuildRequires:  python2-openstackdocstheme
BuildRequires:  python2-os-win
BuildRequires:  python2-requests >= 2.14.2
BuildRequires:  python2-six >= 1.10.0
BuildRequires:  python2-setuptools
BuildRequires:  python2-oslo-privsep >= 1.23.0
%if 0%{?fedora} > 0
BuildRequires:  python2-retrying
%else
BuildRequires:  python-retrying
%endif

%description -n python2-%{pypi_name}
%{common_desc}

%if 0%{?with_python3}
%package -n python3-%{pypi_name}
Summary:        OpenStack Cinder brick library for managing local volume attaches
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3-pbr
Requires:       python3-babel >= 2.3.4
Requires:       python3-eventlet >= 0.18.2
Requires:       python3-oslo-concurrency >= 3.25.0
Requires:       python3-oslo-i18n >= 3.15.3
Requires:       python3-oslo-log >= 3.36.0
Requires:       python3-oslo-service >= 1.24.0
Requires:       python3-oslo-utils >= 3.33.0
Requires:       python3-requests >= 2.14.2
Requires:       python3-retrying
Requires:       python3-six >= 1.10.0
Requires:       python3-oslo-privsep >= 1.23.0
Requires:       python3-os-win
Requires:       device-mapper-multipath
Requires:       sg3_utils

BuildRequires:  python3-devel
BuildRequires:  python3-ddt
BuildRequires:  python3-pbr >= 2.0.0
BuildRequires:  python3-reno
BuildRequires:  python3-sphinx
BuildRequires:  python3-oslo-concurrency  >= 3.8.0
BuildRequires:  python3-oslo-i18n >= 3.15.3
BuildRequires:  python3-oslo-log >= 3.36.0
BuildRequires:  python3-oslo-service >= 1.24.0
BuildRequires:  python3-openstackdocstheme
BuildRequires:  python3-retrying
BuildRequires:  python3-os-win
BuildRequires:  python3-requests >= 2.14.2
BuildRequires:  python3-six >= 1.10.0
BuildRequires:  python3-setuptools
BuildRequires:  python3-oslo-privsep >= 1.23.0

%description -n python3-%{pypi_name}
%{common_desc}

%endif

%prep
%autosetup -n %{pypi_name}-%{upstream_version} -S git


%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif

%install
%py2_install
# generate html docs
%{__python2} setup.py build_sphinx -b html
# remove the sphinx-build leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}

%if 0%{?with_python3}
%py3_install
%endif

# Move config files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap
mv %{buildroot}/usr/etc/os-brick/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap

%files -n python2-%{pypi_name}
%license LICENSE
%doc doc/build/html README.rst
%{python2_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%exclude %{python2_sitelib}/os_brick/tests

%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%license LICENSE
%doc doc/build/html README.rst
%{python3_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%exclude %{python3_sitelib}/os_brick/tests
%endif

%changelog
* Wed Oct 28 2020 Miguel Garcia <mgarciac@redhat.com> 2.3.9-7
- iscsi: Add _get_device_link retry when waiting for /dev/disk/by-id/ to populate

* Mon Aug 24 2020 Sofia Enriquez <senrique@redhat.com> 2.3.9-6
- linuxscsi: Stop waiting for multipath devices during extend_volume (rhbz#1782499)

* Mon Aug 03 2020 Eric Harney <eharney@redhat.com> 2.3.9-5
- Read mounts from /proc/mounts instead of running mount (rhbz #1784947)

* Mon Jun 22 2020 Brian Rosmaita <brosmait@redhat.com> 2.3.9-4
- Fix "Remove VxFlex OS credentials" regression (rhbz#1847024)
- Remove VxFlex OS credentials from connection_properties (rhbz#1847024)

* Tue May 19 2020 Lee Yarwood <lyarwood@redhat.com> 2.3.9-3
- rbd: Correct local_attach disconnect test and showmapped arguments (rhbz#1824124)

* Mon Apr 27 2020 Lee Yarwood <lyarwood@redhat.com> 2.3.9-2
- rbd: Use showmapped to find the root RBD device during disconnect_volume (rhbz#1824124)

* Wed Jan 29 2020 Miguel Garcia <mgarciac@redhat.com> 2.3.9-1
- Update to 2.3.9

* Wed Dec 11 2019 Gorka Eguileor <geguileo@redhat.com> 2.3.8-2
- Fix FC scan too broad (RHBZ#1757297)
- Handle None value 'inititator_target_map'

* Mon Oct 07 2019 Steve Linabery <slinaber@redhat.com> 2.3.8-1
- Update to 2.3.8

* Tue Jul 16 2019 Pablo Caruana <pcaruana@redhat.com> 2.3.7-2
- FC: Ignore some HBAs from map for single WWNN (rhbz#1721080)

* Tue Jun 04 2019 Steve Linabery <slinaber@redhat.com> 2.3.7-1
- Update to 2.3.7

* Fri May 17 2019 Alan Bishop <abishop@redhat.com> 2.3.5-2
- Fix FC case sensitive scanning (rhbz#1710375)

* Fri Feb 15 2019 RDO <dev@lists.rdoproject.org> 2.3.5-1
- Update to 2.3.5

* Tue Jan 29 2019 Steve Linabery <slinaber@redhat.com> 2.3.4-2
- Add dep on sysfsutils, sync with queens-rdo spec

* Mon Nov 26 2018 Jon Schlueter <jschluet@redhat.com> 2.3.4-1
- Update to 2.3.4 (rhbz#1653425)

* Wed Oct 17 2018 Jon Schlueter <jschluet@redhat.com> 2.3.3-1
- Update to 2.3.3 (rhbz#1640406)

* Thu Oct 11 2018 Elise Gafford <egafford@redhat.com> 2.3.2-6
- Succeed on iSCSI detach when path just went down (rhbz#1628471)

* Thu Sep 20 2018 Alan Bishop <abishop@redhat.com> 2.3.2-5
- FC fix for scanning only connected HBA's (rhbz#1631024)

* Tue Sep 18 2018 Gorka Eguileor <geguileo@redhat.com> 2.3.2-4
- Improve iSCSI device detection speed (RHBZ#1629873)

* Tue Sep 18 2018 Gorka Eguileor <geguileo@redhat.com> 2.3.2-3
- Improve detection of multipathd running (RHBZ#1619485)

* Fri Aug 31 2018 Gorka Eguileor <geguileo@redhat.com> 2.3.2-2
- Fix multipath disconnect with path failure (RHBZ#1607196)

* Wed Jul 25 2018 Jon Schlueter <jschluet@redhat.com> 2.3.2-1
- Update to 2.3.2 (rhbz#1608341)
- Add dependency on sg3_utils (rhbz#1602981)

* Tue Apr 10 2018 Jon Schlueter <jschluet@redhat.com> 2.3.1-1
- Update to 2.3.1

* Thu Mar 29 2018 Eric Harney <eharney@redhat.com> 2.3.0-2
- Add dependency on device-mapper-multipath

* Sun Feb 11 2018 RDO <dev@lists.rdoproject.org> 2.3.0-1
- Update to 2.3.0

